#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#       Copyright (C) 2007-2008 GFORGX, NoteFinder Team <gforgx@gmail.com>
#
#       Redistribution and use in source and binary forms, with or without
#       modification, are permitted provided that the following conditions are
#       met:
#
#       * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#       * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following disclaimer
#       in the documentation and/or other materials provided with the
#       distribution.
#       * Neither the name of the project NoteFinder and author's name nor the names of 
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#       THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#      "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#       LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#       A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#       OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#       SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#       LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#       DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#       THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#       (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#       OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import os
import sys

from PyQt4 import QtCore, QtGui

from libnofi import Storage
import notefinder_rc
from add_img import Ui_AddImageDialog
from message_impl import Message

class AddImage(QtGui.QDialog):
    def __init__(self, parent = None):
        QtGui.QDialog.__init__(self, parent)
        self.ui = Ui_AddImageDialog()
        self.ui.setupUi(self)
    
        # Connections
        self.connect(self.ui.fsButton, QtCore.SIGNAL("clicked()"), self.open)
        self.connect(self.ui.buttonBox, QtCore.SIGNAL("accepted()"), self.add)

    def open(self):
        ''' Opens file chooser dialog '''
        fileDialog = QtGui.QFileDialog()
        fileDialog.setWindowTitle(self.trUtf8("Import entry"))
        fileDialog.setFilter(self.trUtf8("Image Files (*.png *.jpg *.bmp)"))
        fileDialog.exec_()
        file = unicode(str(fileDialog.selectedFiles()[0].toUtf8()), 'utf')
        self.ui.pathEdit.setText(file)
        self.ui.nameEdit.setText(os.path.splitext(os.path.split(file)[1])[0])
    
    def add(self):
        ''' Adds image '''
        path = unicode(str(self.ui.pathEdit.text().toUtf8()), 'utf').encode(sys.getfilesystemencoding())
        name = str(self.ui.nameEdit.text().toUtf8())
        if path != '' and name != '':
            if not ("/" in name) and not ("\\" in name) and not ("?" in name) and not ('"' in name)\
                and not (":" in name) and not ("<" in name) and not (">" in name) and not ("|" in name):
                if (os.path.exists(path) and os.path.isfile(path)):
                    try:
                        Storage().addImage(path, name)
                    except:
                        self.message.ui.message.setText("Failed to add image")
                        self.message.show()
                        self.message.raise_()
                        self.message.activateWindow()
                else:
                    self.message.ui.message.setText("File doesn't exist")
                    self.message.show()
                    self.message.raise_()
                    self.message.activateWindow()
            else:
                self.message.ui.message.setText(self.trUtf8('<html><body><p><b>Failed to save entry.<b></p>\
                    <p>Entry name cannot contain following characters: / | \ < > " ? :</p></body></html>'))
                self.message.show()
                self.message.raise_()
                self.message.activateWindow()
                self.accept()