#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#       Copyright (C) 2007-2008 GFORGX, NoteFinder Team <gforgx@gmail.com>
#
#       Redistribution and use in source and binary forms, with or without
#       modification, are permitted provided that the following conditions are
#       met:
#
#       * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#       * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following disclaimer
#       in the documentation and/or other materials provided with the
#       distribution.
#       * Neither the name of the project NoteFinder and author's name nor the names of 
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#       THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#      "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#       LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#       A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#       OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#       SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#       LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#       DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#       THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#       (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#       OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from PyQt4 import QtCore, QtGui

from libnofi import Note
from rename import Ui_RenameDialog
from message_impl import Message

class Rename(QtGui.QDialog):
    def __init__(self, parent = None):
        QtGui.QDialog.__init__(self, parent)
        self.ui = Ui_RenameDialog()
        self.ui.setupUi(self)
        self.note = None

        # Dialogs
        self.message = Message()

        # Connections
        self.connect(self.ui.buttonBox, QtCore.SIGNAL("accepted()"), self.rename)
        
    def rename(self):
        name = str(self.ui.lineEdit.text().toUtf8())
        if name == '':
            self.message.ui.message.setText("Empty title")
            self.message.show()
        elif "/" in name or '\\' in name or '"' in name or '?' in name or ':' in name\
            or '<' in name or '>' in name:
            self.message.ui.message.setText('Entry title may not contain following characters: / | \ < > " ? :')
            self.message.show()
        elif Note(name).exists():
            self.message.ui.message.setText(self.trUtf8("Entry '%s' already exists" % (name)))
            self.message.show()
        else:
            try:
                Note(self.note).rename(name)
            except:
                self.message.ui.message.setText(self.trUtf8("Permission denied or disk space is not available"))
                self.message.show()