#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#       Copyright (C) 2007-2008 GFORGX, NoteFinder Team <gforgx@gmail.com>
#
#       Redistribution and use in source and binary forms, with or without
#       modification, are permitted provided that the following conditions are
#       met:
#
#       * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#       * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following disclaimer
#       in the documentation and/or other materials provided with the
#       distribution.
#       * Neither the name of the project NoteFinder and author's name nor the names of 
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#       THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#      "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#       LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#       A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#       OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#       SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#       LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#       DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#       THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#       (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#       OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

from PyQt4 import QtCore, QtGui

from libnofi import Note, TODO
from notefinder import plugin, notefinder_rc

class AddTodo(plugin.Plugin):
    def __init__(self, parent = None):
        plugin.Plugin.__init__(self, parent)
        self.setText("Add TODO")
        self.setIcon(QtGui.QIcon(":/todo.png"))
        self.main = None
        
        # Dialog
        self.dialog = QtGui.QDialog()
        self.dialog.setWindowTitle("Add TODO")
        self.dialog.setWindowIcon(QtGui.QIcon(":/todo.png"))
        self.vLayout = QtGui.QVBoxLayout(self.dialog)
        self.hLayout = QtGui.QHBoxLayout()
        self.hint = QtGui.QLabel("Select task and enter additional information")
        self.comboBox = QtGui.QComboBox()
        self.comboBox.addItems(["Call", "Visit", "Buy", "Write", "E-mail", "Blog about", "Don't miss", "Don't forget", "Watch", "Draw", #special for Dr.OnX ;)
            "Read", "Make", "Congratulate", "Download"])
        self.hLayout.addWidget(self.comboBox)
        self.editor = QtGui.QLineEdit()
        self.hLayout.addWidget(self.editor)
        self.buttonBox = QtGui.QDialogButtonBox()
        self.buttonBox.setOrientation(QtCore.Qt.Horizontal)
        self.buttonBox.setStandardButtons(QtGui.QDialogButtonBox.Cancel|QtGui.QDialogButtonBox.Ok)
        self.vLayout.addWidget(self.hint)
        self.vLayout.addLayout(self.hLayout)
        self.vLayout.addWidget(self.buttonBox)
        
        # Connections    
        self.connect(self.buttonBox, QtCore.SIGNAL("accepted()"), self.add)
        self.connect(self.buttonBox, QtCore.SIGNAL("rejected()"), self.dialog.close)
    
    def do(self):
        self.dialog.show()
    
    def add(self):
        name = str(self.comboBox.currentText().toUtf8()) + " " + str(self.editor.text().toUtf8())
        note = Note(name)
        if not "/" in name and not '\\' in name and not '"' in name and not '?' in name\
            and not  ':' in name and not "<" in name and not ">" in name and not "|" in name:
            if not note.exists():
                note.write("")
                TODO().addEntry(name)
                self.dialog.close()
                self.showMessage("Done!")
                self.emit(QtCore.SIGNAL("done()"))
            else:
                self.showMessage("Note already exists")
        else:
            self.showMessage('Entry title may not contain following characters: / | \ < > " ? :')
