#!/usr/bin/python
# -*- coding: utf-8 -*-
#
#       Copyright (C) 2008 GFORGX <gforgx@gmail.com>
#
#       Redistribution and use in source and binary forms, with or without
#       modification, are permitted provided that the following conditions are
#       met:
#
#       * Redistributions of source code must retain the above copyright
#       notice, this list of conditions and the following disclaimer.
#       * Redistributions in binary form must reproduce the above
#       copyright notice, this list of conditions and the following disclaimer
#       in the documentation and/or other materials provided with the
#       distribution.
#       * Neither the name of the  nor the names of its
#       contributors may be used to endorse or promote products derived from
#       this software without specific prior written permission.
#
#       THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
#      "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
#       LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
#       A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
#       OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
#       SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
#       LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
#       DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
#       THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
#       (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
#       OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

import sys

from notefinder import plugin, notefinder_rc
from libnofi import Note
from PyQt4 import QtCore, QtGui
from pycreole import wiki2html

class Export2Html(plugin.Plugin):
    def __init__(self, parent = None):
        plugin.Plugin.__init__(self, parent)
        self.setText("Export entry to HTML")
        self.setIcon(QtGui.QIcon(":/bold.png"))
        self.main = None
    
    def do(self):
        note = self.currentNote()
        if note != None:
            dlg = QtGui.QFileDialog()
            dlg.setWindowTitle("Save as")
            dlg.setAcceptMode(dlg.AcceptSave)
            dlg.exec_()
            file = unicode(str(dlg.selectedFiles()[0].toUtf8()), 'utf').encode(sys.getfilesystemencoding())
            fd = open(file, 'w')
            fd.write(wiki2html(unicode(Note(note).getText(), "utf")))
            fd.close()